// xml.h

#ifndef _xml_h_included_
#define _xml_h_included_

#include <libxml/tree.h>
#include <glib.h>

// save xml file
void xml_save(xmlDocPtr doc,
              const gchar *path);

// find existing or create new xml node
// using path, attribute name/value and default value
xmlNodePtr xml_find(xmlNodePtr   node,
                    const gchar *path,
                    bool         create = false,
                    const gchar *def = 0,
                    const gchar *attr_name = 0,
                    const gchar *attr_value = 0);

// find next node with same name
xmlNodePtr xml_next(xmlNodePtr   node,
                    bool         create = false,
                    const gchar *def = 0);

// get or set xml node attribute value
const gchar *xml_attr(xmlNodePtr   node,
                      const gchar *attr_name,
                      const gchar *attr_value = 0);

// get or set xml node name value
const gchar *xml_name(xmlNodePtr   node,
                      const gchar *name = 0);
// get or xml node content
gchar *xml_content(xmlNodePtr   node,
                   const gchar *content = 0);

// remove xml node
void xml_remove(xmlNodePtr node);

// compare two utf8 strings
int utf8_cmp(const gchar *pc1,
             const gchar *pc2);

#endif

